"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var UniqueReducible_1 = require('../UniqueReducible');
var Status_1 = require('./Status');
var StatusReporter = (function (_super) {
    __extends(StatusReporter, _super);
    function StatusReporter(synchronized) {
        _super.call(this);
        this._status = new Status_1.default(synchronized);
    }
    Object.defineProperty(StatusReporter.prototype, "status", {
        get: function () {
            return this._status;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StatusReporter.prototype, "valid", {
        get: function () {
            return this.checkValidity();
        },
        enumerable: true,
        configurable: true
    });
    StatusReporter.prototype.clone = function () {
        var clone = this.createInstance();
        this.cloneOverride(clone);
        return clone;
    };
    StatusReporter.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._status = this._status;
    };
    return StatusReporter;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = StatusReporter;
